#include<bits/stdc++.h>

using namespace std;

#define ll long long

int main(){

    ll n,q,e=0;
    cin>>n>>q;
    vector<ll> a(n),b(n),p(q);

    for(int i=0;i<n;i++){
        cin>>a[i];
        cin>>b[i];
    }
    for(int i=0;i<q;i++){
        cin>>p[i];
    }

    for(int i=0;i<q;i++)
    {
        e=0;
        for(int j=0;j<n;j++){
            p[i]=p[i]-a[j];
            e+=1;
            if(p[i]<=0){
                break;
            }

        }

        if(p[i]>0){
            cout<<"-1"<<"\n";
        }
        else{
            cout<<e<<"\n";
        }



    }



}